
	      % function used to find the eigenvectors and eigenvalues
function [eigvalueMatrix,eigV] = singletMatrixEigBCC(U,V,V_prime,t,t_prime,energy,px,py,pz)
  
				% integral variables
  Loo     = bccIntegration(t,t_prime,energy, 0, 0, 0,px,py,pz,0);
  
  maxcoup = abs(U);
  if (abs(V) > maxcoup)
    maxcoup = abs(V);
  end
  if (abs(V_prime) > maxcoup)
    maxcoup = abs(V_prime);
  end

  mincoup = maxcoup;
  if ((abs(U) < mincoup) && (abs(U)>0))
    mincoup = abs(U);
  end
  if ((abs(V) < mincoup) && (abs(V)>0))
    mincoup = abs(V);
  end
  if ((abs(V_prime) < mincoup) && (abs(V_prime)>0))
    mincoup = abs(V_prime);
  end
  
  mval = abs(Loo .* mincoup ./ maxcoup);

  disp("L00")
  
  Lp1p1p1 = bccIntegration(t,t_prime,energy, 1, 1, 1,px,py,pz,mval); %Lm1m1m1 = bccIntegration(t_prime,energy, -1, -1, -1,px,py,pz);

  disp("..")
  
  Lm1p1p1 = bccIntegration(t,t_prime,energy, -1, 1, 1,px,py,pz,mval); %Lp1m1m1 = bccIntegration(t_prime,energy, 1, -1, -1,px,py,pz); 
  disp("..")

  Lp1m1p1 = bccIntegration(t,t_prime,energy, 1, -1, 1,px,py,pz,mval); %Lm1p1m1 = bccIntegration(t_prime,energy, -1, 1, -1,px,py,pz); 
  disp("..")

  Lp1p1m1 = bccIntegration(t,t_prime,energy, 1, 1, -1,px,py,pz,mval); % Lm1m1p1 = bccIntegration(t_prime,energy, -1, -1, 1,px,py,pz);

  disp("L111")

  
  Lp2p20  = bccIntegration(t,t_prime,energy, 2, 2, 0, px,py,pz,mval); % Lm2m20  = bccIntegration(t_prime,energy, -2, -2, 0, px,py,pz);
  disp("..")
  Lp2m20  = bccIntegration(t,t_prime,energy, 2, -2, 0, px,py,pz,mval); % Lm2p20  = bccIntegration(t_prime,energy, -2, 2, 0, px,py,pz);
  disp("..")
  
  Lp20p2  = bccIntegration(t,t_prime,energy, 2, 0, 2, px,py,pz,mval); % Lm20m2  = bccIntegration(t_prime,energy, -2, 0, -2, px,py,pz); 
  disp("..")
  Lp20m2  = bccIntegration(t,t_prime,energy, 2, 0, -2, px,py,pz,mval); %Lm20p2  = bccIntegration(t_prime,energy, -2, 0, 2, px,py,pz); 
  disp("..")
  
  L0p2p2  = bccIntegration(t,t_prime,energy, 0, 2, 2, px,py,pz,mval);  %L0m2m2  = bccIntegration(t_prime,energy, 0, -2, -2, px,py,pz); 
  disp("..")
  L0p2m2  = bccIntegration(t,t_prime,energy, 0, 2, -2, px,py,pz,mval); %L0m2p2  = bccIntegration(t_prime,energy, 0, -2, 2, px,py,pz); 
  disp("L220")
  
  
  Lp2p2p2   = bccIntegration(t,t_prime,energy, 2, 2, 2,px,py,pz,mval);  % Lm2m2m2   = bccIntegration(t_prime,energy, -2, -2, -2,px,py,pz);
  disp("..")
  Lm2p2p2   = bccIntegration(t,t_prime,energy, -2, 2, 2,px,py,pz,mval); %Lp2m2m2   = bccIntegration(t_prime,energy, 2, -2, -2,px,py,pz); 
  disp("..")
  Lp2m2p2   = bccIntegration(t,t_prime,energy, 2, -2, 2,px,py,pz,mval); %Lm2p2m2   = bccIntegration(t_prime,energy, -2, 2, -2,px,py,pz); 
  disp("..")
  Lp2p2m2   = bccIntegration(t,t_prime,energy, 2, 2, -2,px,py,pz,mval); %Lm2m2p2   = bccIntegration(t_prime,energy, -2, -2, 2,px,py,pz); 
  disp("L222")
  
  Lp200    = bccIntegration(t,t_prime,energy, 2, 0, 0,px,py,pz,mval); % Lm200    = bccIntegration(t_prime,energy, -2, 0, 0,px,py,pz);
  disp("..")
  L0p20    = bccIntegration(t,t_prime,energy, 0, 2, 0,px,py,pz,mval); % L0m20    = bccIntegration(t_prime,energy, 0, -2, 0,px,py,pz);
  disp("..")
  L00p2    = bccIntegration(t,t_prime,energy, 0, 0, 2,px,py,pz,mval);
  disp("L200")
  
  Lp100    = bccIntegration(t,t_prime,energy, 1, 0, 0,px,py,pz,mval);
  disp("..")
  L0p10    = bccIntegration(t,t_prime,energy, 0, 1, 0,px,py,pz,mval);
  disp("..")
  L00p1    = bccIntegration(t,t_prime,energy, 0, 0, 1,px,py,pz,mval);
  disp("L100")
  
  Lp3p1p1    = bccIntegration(t,t_prime,energy, 3, 1, 1,px,py,pz,mval);
  disp("..")
  Lp1p3p1    = bccIntegration(t,t_prime,energy, 1, 3, 1,px,py,pz,mval);
  disp("..")
  Lp1p1p3    = bccIntegration(t,t_prime,energy, 1, 1, 3,px,py,pz,mval);
  disp("..")
  
  Lm3p1p1    = bccIntegration(t,t_prime,energy, -3, 1, 1,px,py,pz,mval);
  disp("..")
  Lm1p3p1    = bccIntegration(t,t_prime,energy, -1, 3, 1,px,py,pz,mval);
  disp("..")
  Lm1p1p3    = bccIntegration(t,t_prime,energy, -1, 1, 3,px,py,pz,mval);
  disp("..")
  
  Lp3m1p1    = bccIntegration(t,t_prime,energy, 3, -1, 1,px,py,pz,mval);
  disp("..")
  Lp1m3p1    = bccIntegration(t,t_prime,energy, 1, -3, 1,px,py,pz,mval);
  disp("..")
  Lp1m1p3    = bccIntegration(t,t_prime,energy, 1, -1, 3,px,py,pz,mval);
  disp("..")
  
  Lp3p1m1    = bccIntegration(t,t_prime,energy, 3, 1, -1,px,py,pz,mval);
  disp("..")
  Lp1p3m1    = bccIntegration(t,t_prime,energy, 1, 3, -1,px,py,pz,mval);
  disp("..")
  Lp1p1m3    = bccIntegration(t,t_prime,energy, 1, 1, -3,px,py,pz,mval);
  disp("L311")

% Only contributes to cases where V_prime present, so only do integrals
% if V_prime > 0
  
  Lp400 = 0
  L0p40 = 0
  L00p4 = 0
  if (abs(V_prime) > 0)
    Lp400      = bccIntegration(t,t_prime,energy, 4, 0, 0,px,py,pz,mval);
    disp("..")
    L0p40      = bccIntegration(t,t_prime,energy, 0, 4, 0,px,py,pz,mval);
    disp("..")
    L00p4      = bccIntegration(t,t_prime,energy, 0, 0, 4,px,py,pz,mval);
  end
  
  disp("L400")  
				% define matrix elements
  A11 = -U*Loo;
  A12 = -2.0*V*Lp1p1p1;%*exp(-1i*px/4)*exp(-1i*py/4)*exp(-1i*pz/4);
  A13 = -2.0*V*Lm1p1p1;%*exp(1i*px/4)*exp(-1i*py/4)*exp(-1i*pz/4);
  A14 = -2.0*V*Lp1m1p1;%*exp(-1i*px/4)*exp(1i*py/4)*exp(-1i*pz/4);
  A15 = -2.0*V*Lp1p1m1;%*exp(-1i*px/4)*exp(-1i*py/4)*exp(1i*pz/4);

  A16 = -2.0*V_prime*Lp200;
  A17 = -2.0*V_prime*L0p20;
  A18 = -2.0*V_prime*L00p2;
  
  
  A21 = -U*Lp1p1p1;%*exp(1i*px/4)*exp(1i*py/4)*exp(1i*pz/4);
  A22 = -V*(Loo + Lp2p2p2); 
  A23 = -V*(Lp200 + L0p2p2);%*exp(1i*px/2);
  A24 = -V*(L0p20 + Lp20p2);%*exp(1i*py/2); 
  A25 = -V*(L00p2 + Lp2p20);%*exp(1i*pz/2);
  A26 = -V_prime*(Lm1p1p1 + Lp3p1p1);
  A27 = -V_prime*(Lp1m1p1 + Lp1p3p1);
  A28 = -V_prime*(Lp1p1m1 + Lp1p1p3);
  
  
  A31 = -U*Lm1p1p1;%*exp(-1i*px/4)*exp(1i*py/4)*exp(1i*pz/4); 
  A32 = -V*(Lp200 + L0p2p2);%*exp(-1i*px/2);
  A33 = -V*(Loo + Lm2p2p2);
  A34 = -V*(Lp2m20 + L00p2);%*exp(-1i*px/2)*exp(1i*py/2);
  A35 = -V*(Lp20m2 + L0p20);%*exp(-1i*px/2)*exp(1i*pz/2);
  A36 = -V_prime*(Lm3p1p1 + Lp1p1p1);
  A37 = -V_prime*(Lp1p1m1 + Lm1p3p1);
  A38 = -V_prime*(Lp1m1p1 + Lm1p1p3);
  
  
  A41 = -U*Lp1m1p1;%*exp(1i*px/4)*exp(-1i*py/4)*exp(1i*pz/4);
  A42 = -V*(L0p20 + Lp20p2);%*exp(-1i*py/2); 
  A43 = -V*(Lp2m20 + L00p2);%*exp(1i*px/2)*exp(-1i*py/2);
  A44 = -V*(Loo + Lp2m2p2); 
  A45 = -V*(L0p2m2 + Lp200);%*exp(-1i*py/2)*exp(1i*pz/2);
  A46 = -V_prime*(Lp1p1m1 + Lp3m1p1);
  A47 = -V_prime*(Lp1m3p1 + Lp1p1p1);
  A48 = -V_prime*(Lm1p1p1 + Lp1m1p3);
            
  A51 = -U*Lp1p1m1;%*exp(1i*px/4)*exp(1i*py/4)*exp(-1i*pz/4);
  A52 = -V*(L00p2 + Lp2p20);%*exp(-1i*pz/2); 
  A53 = -V*(Lp20m2 + L0p20);%*exp(1i*px/2)*exp(-1i*pz/2); 
  A54 = -V*(L0p2m2 + Lp200);%*exp(1i*py/2)*exp(-1i*pz/2); 
  A55 = -V*(Loo + Lp2p2m2);
  A56 = -V_prime*(Lp1m1p1 + Lp3p1m1);
  A57 = -V_prime*(Lm1p1p1 + Lp1p3m1);
  A58 = -V_prime*(Lp1p1m3 + Lp1p1p1);
  
  A61 = -U*Lp200;
  A62 = -V*(Lm1p1p1 + Lp3p1p1);
  A63 = -V*(Lm3p1p1 + Lp1p1p1);
  A64 = -V*(Lp1p1m1 + Lp3m1p1);
  A65 = -V*(Lp1m1p1 + Lp3p1m1);
  A66 = -V_prime*(Loo + Lp400);
  A67 = -V_prime*(Lp2m20 + Lp2p20);
  A68 = -V_prime*(Lp20m2 + Lp20p2);
  
  A71 = -U*L0p20;
  A72 = -V*(Lp1m1p1 + Lp1p3p1);
  A73 = -V*(Lp1p1m1 + Lm1p3p1);
  A74 = -V*(Lp1m3p1 + Lp1p1p1);
  A75 = -V*(Lm1p1p1 + Lp1p3m1);
  A76 = -V_prime*(Lp2m20 + Lp2p20);
  A77 = -V_prime*(Loo + L0p40);
  A78 = -V_prime*(L0p2m2 + L0p2p2);
  
  
  A81 = -U*L00p2;
  A82 = -V*(Lp1p1m1 + Lp1p1p3);
  A83 = -V*(Lp1m1p1 + Lm1p1p3);
  A84 = -V*(Lm1p1p1 + Lp1m1p3);
  A85 = -V*(Lp1p1m3 + Lp1p1p1);
  A86 = -V_prime*(Lp20m2 + Lp20p2);
  A87 = -V_prime*(L0p2m2 + L0p2p2);
  A88 = -V_prime*(Loo + L00p4);
  
  
  
  allMatrix = [A11 A12 A13 A14 A15 A16 A17 A18 ;...
               A21 A22 A23 A24 A25 A26 A27 A28 ;...
               A31 A32 A33 A34 A35 A36 A37 A38 ;...
               A41 A42 A43 A44 A45 A46 A47 A48 ;...
               A51 A52 A53 A54 A55 A56 A57 A58 ;...
               A61 A62 A63 A64 A65 A66 A67 A68 ;...
               A71 A72 A73 A74 A75 A76 A77 A78 ;...
               A81 A82 A83 A84 A85 A86 A87 A88 ];
  
       %                      eigvalueMatrix = double(eig(allMatrix));
  [eigV,eigvalueMatrix] = eig(allMatrix,'vector');
%  [eigvalueMatrix ind] = sort(eigvalueMatrix, 'ComparisonMethod', 'real');
[eigvalueMatrixReal ind] = sort(real(eigvalueMatrix), 'ascend');
eigvalueMatrix = eigvalueMatrix(ind);
eigV = eigV(:,ind);

    % eigV should be eigenvectors, eigvalueMatrix should be diagonal vector of eigenvalues
    % presumably get the radius from eigV???
    
end

