% binary search algorithm to select interval where the energy of bound particles lies
function [a, b, eigvalret] = check_root_interval(ind,upper_bound,lower_bound,mid_point,uu,vv,v_prime,t,t_prime,tol,px,py,pz)
  lower_bound
  mid_point
  upper_bound
  
% IMPORTANT: MUST USE THE ABSOLUTE TOLERANCE AND NOT THE RELATIVE TOLERANCE HERE OR HAVE PROBLEMS FOR DEEPLY BOUND STATES
%  if abs(upper_bound-lower_bound)/abs(upper_bound) <= tol
  if abs(upper_bound-lower_bound) <= tol
				%    if (abs(s3(ind)-1.0) <= tol)
    a = lower_bound;
    b = upper_bound;
    [s3,~] = singletMatrixEig(uu, vv, v_prime, t, t_prime, mid_point, px,py,pz);
    eigvalret = s3(ind);
    return
  end
  
  [s3,~] = singletMatrixEig(uu, vv, v_prime, t, t_prime, mid_point, px,py,pz)
  
  
%  [s1,~] = singletMatrixEig(uu, vv, v_prime, t, t_prime, lower_bound, px,py,pz)
  
		 %      if (real(s1(ind)) < 1) && (real(s3(ind)) >= 1)
  if (real(s3(ind)) >= 1)
	 %         disp('PART A')
	 %        if abs(s1(ind)-s3(ind))<= 0.000001
	 % if (abs(upper_bound-lower_bound)/abs(upper_bound))<= 0.0001
	 %  a = lower_bound;
	 %  b = mid_point;
	 %  return 
	 %else
	
    upper_bound = mid_point;
    mid_point = (lower_bound + upper_bound)/2.0;
    
    
    [a, b, eigvalret] = check_root_interval(ind,upper_bound,lower_bound,mid_point,uu,vv,v_prime,t,t_prime,tol,px,py,pz);
				%end
    
  else
	  %elseif (s3(ind) < 1) && (s2(ind) >= 1)
	  %         disp('PART B')
	  %if (abs(upper_bound-lower_bound)/abs(upper_bound))<= 0.0001
	  %        if abs(s2(ind)-s3(ind))<= 0.0001
	  %a = mid_point;
	  %  b = upper_bound;
	  %  return 
	  %else
    
    lower_bound = mid_point;
    mid_point = (lower_bound + upper_bound)/2.0;
    
    
    [a, b, eigvalret] = check_root_interval(ind,upper_bound,lower_bound,mid_point,uu,vv,v_prime,t,t_prime,tol,px,py,pz);
				%end
    
    
				%    else
				%        a = 0;
				%        b = 0;
  end
end
